// Code generated by github.com/chouandy/goex/awsex/gen-api/main.go. DO NOT EDIT.

package gisapi

import (
	"github.com/aws/aws-sdk-go-v2/aws"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/aws-sdk-go-v2/private/protocol/restjson"
)

// GISAPI provides the API operation methods for making requests to
// GISAPI. See this package's package overview docs
// for details on the service.
//
// GISAPI methods are safe to use concurrently. It is not safe to
// modify mutate any of the struct's properties though.
type GISAPI struct {
	*aws.Client
}

// Used for custom client initialization logic
var initClient func(*GISAPI)

// Used for custom request initialization logic
var initRequest func(*GISAPI, *aws.Request)

// Service information constants
const (
	ServiceName = "execute-api" // Service endpoint prefix API calls made to.
	EndpointsID = ServiceName   // Service ID for Regions and Endpoints metadata.
)

// New creates a new instance of the GISAPI client with a config.
//
// Example:
//     // Create a GISAPI client from just a config.
//     svc := gisapi.New(myConfig)
func New(config aws.Config) *GISAPI {
	var signingName string
	signingRegion := config.Region

	svc := &GISAPI{
		Client: aws.NewClient(
			config,
			aws.Metadata{
				ServiceName:   ServiceName,
				SigningName:   signingName,
				SigningRegion: signingRegion,
				APIVersion:    "2015-07-09",
			},
		),
	}

	// Handlers
	svc.Handlers.Sign.PushBackNamed(v4.SignRequestHandler)
	svc.Handlers.Build.PushBackNamed(restjson.BuildHandler)
	svc.Handlers.Unmarshal.PushBackNamed(restjson.UnmarshalHandler)
	svc.Handlers.UnmarshalMeta.PushBackNamed(restjson.UnmarshalMetaHandler)
	svc.Handlers.UnmarshalError.PushBackNamed(restjson.UnmarshalErrorHandler)

	// Run custom client initialization if present
	if initClient != nil {
		initClient(svc)
	}

	return svc
}

// newRequest creates a new request for a GISAPI operation and runs any
// custom request initialization.
func (c *GISAPI) newRequest(op *aws.Operation, params, data interface{}) *aws.Request {
	req := c.NewRequest(op, params, data)

	// Run custom request initialization if present
	if initRequest != nil {
		initRequest(c, req)
	}

	return req
}
